XBtnDps={};
XBtnTDps={["CurTime"]=nil,["DPS"]=0,["Dmg"]=0,["Kills"]=0,["New"]=false,["Dura"]=0};
XBtnTHps={["CurTime"]=nil,["HPS"]=0,["Heal"]=0};
XBABILITY_TEXT1 = {
	C_STR,
	C_AGI,
	C_STA,
	C_INT,
	C_MND,
};

XBABILITY_TEXT = {
	MELEE.." "..C_PHYSICAL_DAMAGE,
	MELEE.." "..C_PHYSICAL_ATTACK,
	MELEE.." "..C_PHYSICAL_CRITICAL,
	C_CRITICAL_MAIN_PERCENTAGE,
	C_CRITICAL_OFF_PERCENTAGE,
	MELEE.." "..C_PHYSICAL_HIT,
	PHYSICAL_HIT_RATE,
	RANGE.." "..C_PHYSICAL_DAMAGE,
	RANGE.." "..C_PHYSICAL_ATTACK,
	RANGE.." "..C_PHYSICAL_CRITICAL,
	MAGIC.." "..C_MAGIC_DAMAGE,
	MAGIC.." "..C_MAGIC_ATTACK,
	MAGIC.." "..C_MAGIC_CRITICAL,
	MAGIC.." "..C_MAGIC_HEAL_POINT,
	MAGIC.." "..C_MAGIC_HIT,
	DEFENCE,
	C_PHYSICAL_PARRY,
	C_PHYSICAL_DODGE,
	C_PHYSICAL_RESIST_CRITICAL,
	MAGIC.." "..C_MAGIC_DEFENCE,
	MAGIC.." "..C_MAGIC_DODGE,
	MAGIC.." "..C_MAGIC_RESIST_CRITICAL,
};

XBABILITY = {
	"MELEE_MAIN_DAMAGE",
	"MELEE_ATTACK",
	"MELEE_CRITICAL",
	"MELEE_MAIN_CRITICAL",
	"MELEE_OFF_CRITICAL",
	"PHYSICAL_MAIN_HIT",
	"PHYSICAL_HIT_RATE",
	"RANGE_DAMAGE",
	"RANGE_ATTACK",
	"RANGE_CRITICAL",
	"MAGIC_DAMAGE",
	"MAGIC_ATTACK",
	"MAGIC_CRITICAL",
	"MAGIC_HEAL",
	"MAGIC_HIT",
	"PHYSICAL_DEFENCE",
	"PHYSICAL_PARRY",
	"PHYSICAL_DODGE",
	"PHYSICAL_RESIST_CRITICAL",
	"MAGIC_DEFENCE",
	"MAGIC_DODGE",
	"MAGIC_RESIST_CRITICAL",
};

function XBarDps_OnLoad(this)
	this:RegisterEvent("VARIABLES_LOADED");
	SaveVariables("XBtnDps");
end

XBarDps_OnUpdate=function()
	if not XBtnTDps["CurTime"]==nil then
		if GetTime()-XBtnTDps["CurTime"]>10 then
			XBtnTDps["Active"]=false;
			XBtnTDps["DPS"]=0;
			XBtnTDps["CurTime"]=nil;
		end
	end
	if not XBtnTHps["CurTime"]==nil then
		if GetTime()-XBtnTHps["CurTime"]>10 then
			XBtnTHps["Active"]=false;
			XBtnTHps["HPS"]=0;
			XBtnTHps["CurTime"]=nil;
		end
	end
end
 
function XBarDps_OnEvent(this,event)
	if XBAvgDur~=nil then XBtnTDps["Dura"] = XBarEQDmg_SetColor(XBAvgDur)..XBAvgDur.."%|r"; end
	if event=="VARIABLES_LOADED" then
		this:RegisterEvent("UNIT_HEALTH");
		this:RegisterEvent("COMBATMETER_DAMAGE"); -- arg=_source,_target,_skill,_type,_damage
		this:RegisterEvent("COMBATMETER_HEAL"); -- arg=_source,_target,_skill,_type,_heal
	end
	if event=="UNIT_HEALTH" then
		if UnitHealth("target")==0 and UnitExists("target") and XBtnTDps["New"]==true then
			local playern = UnitName("player");
			if not XBtnDps[playern] then XBtnDps[playern] = 0; end
			XBtnTDps["New"] = false;
			XBtnDps[playern] = XBtnDps[playern] + 1;
			XBtnTDps["Kills"] = XBar_Dec(XBtnDps[playern]);
		end
	end
	if event=="COMBATMETER_DAMAGE" then
		if _source==UnitName("player") then
			if UnitHealth("target") > 0 and UnitExists("target") then XBtnTDps["New"] = true; end
			if not XBtnTDps["Active"] then
				XBtnTDps["Active"]=true;
				XBtnTDps["StartTime"]=(GetTime()-1);
				XBtnTDps["TotalDmg"]=0;
				XBtnTDps["DPS"]=0;
			end
			XBtnTDps["CurTime"]=GetTime();
			XBtnTDps["TotalTime"]=(XBtnTDps["CurTime"]-XBtnTDps["StartTime"]);
			XBtnTDps["Dmg"]=XBar_Dec(_damage);
			XBtnTDps["TotalDmg"]=XBtnTDps["TotalDmg"]+_damage;
			XBtnTDps["DPS"]=XBar_Dec(math.floor(XBtnTDps["TotalDmg"]/XBtnTDps["TotalTime"]));
		else
			return;
		end
	end
	if event=="COMBATMETER_HEAL" then
		if _source==UnitName("player") then
			if not XBtnTHps["Active"] then
				XBtnTHps["Active"]=true;
				XBtnTHps["StartTime"]=(GetTime()-1);
				XBtnTHps["TotalHeal"]=0;
				XBtnTHps["HPS"]=0;
			end
			XBtnTHps["CurTime"]=GetTime();
			XBtnTHps["TotalTime"]=(XBtnTHps["CurTime"]-XBtnTHps["StartTime"]) ;
			XBtnTHps["Heal"]=XBar_Dec(_heal);
			XBtnTHps["TotalHeal"]=XBtnTHps["TotalHeal"]+_heal;
			XBtnTHps["HPS"]=XBar_Dec(math.floor(XBtnTHps["TotalHeal"]/XBtnTHps["TotalTime"]));
		else
			return;
		end
	end
--	Output
	local usrtxt={[1]=XBSet["DpsV1"],[2]=XBSet["DpsV2"]};
	local output="";
	for i=1,2 do
		if (usrtxt) and (usrtxt[i]~="") then
			usrtxt[i],_=string.gsub(usrtxt[i],"%[DPS%]",XBtnTDps["DPS"]);
			usrtxt[i],_=string.gsub(usrtxt[i],"%[DMG%]",(XBtnTDps["Dmg"] or 0));
			usrtxt[i],_=string.gsub(usrtxt[i],"%[HPS%]",XBtnTHps["HPS"]);
			usrtxt[i],_=string.gsub(usrtxt[i],"%[HEAL%]",(XBtnTHps["Heal"] or 0));
			usrtxt[i],_=string.gsub(usrtxt[i],"%[KILLS%]",(XBtnTDps["Kills"] or 0));
			usrtxt[i],_=string.gsub(usrtxt[i],"%[DURA%]",(XBtnTDps["Dura"] or 0));
		end
	end
	if (XBSet["DpsT1"]==true) then output=usrtxt[1]; end
	if (XBSet["DpsT2"]==true) then
		if (XBSet["DpsT1"]==true) then output=output.."\n"..usrtxt[2]; else output=usrtxt[2]; end
	end
	XBarDps_F_Text:SetText(output);
end

function XBarDps_OnClick(this,key)
	if key=="RBUTTON" then
		if IsCtrlKeyDown() then
			XBtnTDps["Kills"] = 0; local playern = UnitName("player");
			XBtnDps[playern] = 0; XBarDps_OnEvent();
		else
			SwapEquipmentItem();
		end
	end
	if (key=="LBUTTON") then XBar_ToggleUI(XBarEQDmg); end
end
function XBarDps_OnEnter(this)
	GameTooltip:SetOwner(this,"ANCHOR_TOPRIGHT", -200,0);
	GameTooltip:SetText(XLng["Ttip"]["Dps1"]);
	GameTooltip:AddLine(XLng["Ttip"]["Dps2"],0,.7,.9);
	GameTooltip:AddLine(XLng["Ttip"]["DpsK"],0,.7,.9);
	GameTooltip:AddSeparator();
	GameTooltip:AddDoubleLine("|cffFFE855"..XLng["Ttip"]["AvgDur"].."|r",XBarEQDmg_AvgDura:GetText());
	GameTooltip:AddDoubleLine("|cffFFE855"..XLng["Legend"]["Dps2"].."|r", XBtnTDps["Kills"]);
	local XBAdd = false;
	for i, v in ipairs(CHARACTERABILITY_ITEMNAME) do
		local base, extra = GetPlayerAbility(v);
		local value;
		if extra>0 then
			value=("|cff00FF00"..(base+extra).."|r / "..base.."+|cff00FF00"..extra);
		elseif extra<0 then
			value=("|cffFF0000"..(base+extra).."|r / "..base.."+|cffFF0000"..extra);
		else
			value=(base+extra);
		end
		if XBAdd == false then
			GameTooltip:AddLine(" ");
			GameTooltip:AddDoubleLine(" ", "|cffFFE855"..C_ABILITY.."|r");
			XBAdd = true;
		end
		GameTooltip:AddDoubleLine(XBABILITY_TEXT1[i], value);
	end
	local XBAdd2 = false;
	for i, v in ipairs(XBABILITY) do
		local base, extra, per = GetPlayerAbility(v);
		if i==7 then
			if extra>0 then
				XBABILITY[v]="|cffFFFF00"..(base+extra).."%|r / "..base.."%+|cffFFFF00"..extra.."%";
			elseif extra<0 then
				XBABILITY[v]="|cffFF0000"..(base+extra).."%|r / "..base.."%|cffFF0000"..extra.."%";
			else
				XBABILITY[v]=base+extra.."%";
			end
		else
			if extra>0 then
				XBABILITY[v]=XBar_Dec("|cffFFFF00"..(base+extra).."|r / "..base.."+|cffFFFF00"..extra);
			elseif extra<0 then
				XBABILITY[v]=XBar_Dec("|cffFF0000"..(base+extra).."|r / "..base.."|cffFF0000"..extra);
			else
				XBABILITY[v]=XBar_Dec(base+extra);
			end
		end
		if XBAdd2 == false then
			GameTooltip:AddSeparator();
			XBAdd2 = true;
		end
		if i==8 or i==11 or i==16 or i==20 then GameTooltip:AddSeparator(); end
		if i==4 or i==5 then
			GameTooltip:AddDoubleLine(" ", string.format("%.2f%%", per));
		elseif i==10 or i==13 then
			GameTooltip:AddDoubleLine(XBABILITY_TEXT[i], XBABILITY[v]);
			GameTooltip:AddDoubleLine(" ", string.format("%.2f%%", per));
		elseif i==17 then
			GameTooltip:AddDoubleLine(XBABILITY_TEXT[i], XBABILITY[v]);
			GameTooltip:AddDoubleLine(" ", string.format("%.2f%%", per));
		else
			GameTooltip:AddDoubleLine(XBABILITY_TEXT[i], XBABILITY[v]);
		end
	end
end