XBtnMoney={["total"]=GetPlayerMoney("copper"),["session"]=0,["spent"]=0};
 
function XBarMoney_OnEvent(this,event)
	if event=="VARIABLES_LOADED" then
		this:RegisterEvent("PLAYER_MONEY");
		this:RegisterEvent("PLAYER_BAG_CHANGED");
	end

	if event=="PLAYER_MONEY" then 
		local temp=XBtnMoney["total"];
		local diff=0;
		XBtnMoney["total"]=GetPlayerMoney("copper");
		if (temp<XBtnMoney["total"]) then
			diff=math.ceil(XBtnMoney["total"]-temp);
			XBtnMoney["session"]=XBtnMoney["session"]+diff;
		elseif (temp>XBtnMoney["total"]) then
			diff=math.ceil(temp-XBtnMoney["total"]);
			XBtnMoney["spent"]=XBtnMoney["spent"]+diff;
		end
	end
	if event=="PLAYER_BAG_CHANGED" or event=="VARIABLES_LOADED" then
		local used, total = GetBagCount();
		local AMBagCount, AMBankCount, PSBagCount, PSBankCount = 0, 0, 0, 0;
		for i = 1, total do
			local index, texture, name, count, locked, quality = GetBagItemInfo(i);
			if name==TEXT("Sys206879_name") then
				AMBagCount = AMBagCount + count;
			elseif name==TEXT("Sys240181_name") then
				PSBagCount = PSBagCount + count;
			end
		end
		local banktotal = GetBankNumItems();
		for i = 1, banktotal do
			local texture, name, count, locked = GetBankItemInfo(i);
			if name==TEXT("Sys206879_name") then
				AMBankCount = AMBankCount + count;
			elseif name==TEXT("Sys240181_name") then
				PSBankCount = PSBankCount + count;
			end
		end
		XBtnMoney["AMCount"] = XBar_Dec(AMBagCount + AMBankCount);
		XBtnMoney["PSCount"] = XBar_Dec(PSBagCount + PSBankCount);
	end
-- Output
	local usrtxt={[1]=XBSet["MoneyV1"],[2]=XBSet["MoneyV2"]};
	local output="";
	for i=1,2 do
		usrtxt[i],_=string.gsub(usrtxt[i],"%[GOLD%]","|cffFFEE80"..XBar_Dec(GetPlayerMoney("copper")).."|r");
		usrtxt[i],_=string.gsub(usrtxt[i],"%[DIAS%]","|cffC7C7FF"..XBar_Dec(GetPlayerMoney("account")).."|r");
		usrtxt[i],_=string.gsub(usrtxt[i],"%[RUBY%]","|cffFFC7C7"..XBar_Dec(GetPlayerMoney("bonus")).."|r");
		usrtxt[i],_=string.gsub(usrtxt[i],"%[COIN%]","|cffC7C7C7"..XBar_Dec(GetPlayerMoney("billdin")).."|r");
		usrtxt[i],_=string.gsub(usrtxt[i],"%[AM%]", "|cffC7FFC7"..XBtnMoney["AMCount"].."|r");
		usrtxt[i],_=string.gsub(usrtxt[i],"%[PS%]", "|cffC7FFC7"..XBtnMoney["PSCount"].."|r");
	end
	if (XBSet["MoneyT1"]==true) then output=usrtxt[1]; end
	if (XBSet["MoneyT2"]==true) then
		if (XBSet["MoneyT1"]==true) then output=output.."\n"..usrtxt[2]; else output=usrtxt[2]; end
	end
	XBarMoney_F_Text:SetText(output);
end