XBtnChars={["tc"]=NONE,["tl"]="Lv",["tcurrExp"]=NONE,["tmaxExp"]=NONE,["tExpd"]=NONE};

function XBarClass_OnEvent(this,event,arg1)
	if event=="VARIABLES_LOADED" then
		this:RegisterEvent("UNIT_LEVEL");
		this:RegisterEvent("UNIT_CLASS_CHANGED");
		this:RegisterEvent("CHAT_MSG_SYSTEM");
		this:RegisterEvent("PLAYER_GET_TITLE");
		this:RegisterEvent("PLAYER_TITLE_ID_CHANGED")
		this:RegisterEvent("CARDBOOKFRAME_UPDATE");
		this:RegisterEvent("PLAYER_HONOR_CHANGED");
		XBarClass_Quest();
	end
	if event=="UNIT_CLASS_CHANGED" or event=="UNIT_LEVEL" or event=="VARIABLES_LOADED" then
		local mainC, subC = UnitClass("player");
		local count, maxNums = GetPlayerNumClasses();
		for i = 1, maxNums do
			local class, token, level, currExp, maxExp, debt = GetPlayerClassInfo(i, true);
			if class~=nil then
				if class==mainC then
					XBtnChars["mc"] = class;
					XBtnChars["ml"] = level;
					XBtnChars["mcurrExp"] = XBar_Dec(currExp);
					XBtnChars["mmaxExp"] = XBar_Dec(maxExp);
				elseif class==subC then
					XBtnChars["sc"] = class;
					XBtnChars["sl"] = level;
					XBtnChars["scurrExp"] = XBar_Dec(currExp);
					XBtnChars["smaxExp"] = XBar_Dec(maxExp);
				elseif count==3 then
					XBtnChars["tc"] = class;
					XBtnChars["tl"] = level;
					XBtnChars["tcurrExp"] = XBar_Dec(currExp);
					XBtnChars["tmaxExp"] = XBar_Dec(maxExp);
					XBtnChars["tExpd"] = XBar_Dec(debt);
				end
			end
		end
		if subC=="" or subC==nil then
			XBtnChars["sc"] = NONE;
			XBtnChars["sl"] = "Lv";
			XBtnChars["scurrExp"] = NONE;
			XBtnChars["smaxExp"] = NONE;
		end
	end
	if event=="CHAT_MSG_SYSTEM" or event=="VARIABLES_LOADED" then
		local dailyCount, dailyPerDay = Daily_count();
		if dailyCount==dailyPerDay then
			XBtnChars["daily"] = "|cffff0000"..dailyCount.."/"..dailyPerDay.."|r";
		else
			XBtnChars["daily"] = dailyCount.."/"..dailyPerDay;
		end
		local totalQuest = GetNumQuestBookButton_QuestBook();
		local finishQuest = 0;
		if totalQuest>0 then
			for i = 1, totalQuest do
				local _Index, _CatalogID, _QuestName, _Track, _QuestLV, bDaily, bDaily_num, iQuestType, _, Complete = GetQuestInfo(i);
				if Complete then
					finishQuest = finishQuest + 1;
				end
			end
			XBtnChars["quest"] = finishQuest.."/"..totalQuest;
		else
			XBtnChars["quest"] = NONE;
		end
	end
	if event=="CHAT_MSG_SYSTEM" then
		if string.find(arg1, string.format(TEXT("QUEST_MSG_FINISHED"), "(.*)")) then
			XBarClass_Quest();
		end
	end
	if event=="PLAYER_HONOR_CHANGED" or event=="VARIABLES_LOADED" then
		XBtnChars["honor"] = XBar_Dec(math.floor(GetPlayerHonorPoint()));
	end
	if event=="PLAYER_GET_TITLE" or event=="PLAYER_TITLE_ID_CHANGED" or event=="VARIABLES_LOADED" then
		UpdateTitleInfo();
		XBtnChars["titleC"] = 0;
		if GetTitleCount()==0 then XBtnChars["titleC"] = NONE; end
		for i = 1, GetTitleCount() do
			local tname, tID, tgeted = GetTitleInfoByIndex(i - 1);
			if tgeted==true then
				local ID = GetCurrentTitle();
				if tID==ID then
					XBtnChars["title"] = tname;
				elseif ID==0 then
					XBtnChars["title"] = NONE;
				end
				XBtnChars["titleC"] = XBtnChars["titleC"] + 1;
			end
		end
	end
	-- if event=="CARDBOOKFRAME_UPDATE" or event=="VARIABLES_LOADED" then
		-- local cardMax, cardCount = 0, 0;
		-- for i = 0, 16 do
			-- local GMax = LuaFunc_GetCardMaxCount(i);
			-- if GMax~=nil and GMax>0 then
				-- cardMax = cardMax + GMax;
				-- cardCount = cardCount + LuaFunc_GetCardCount(i);
			-- end
		-- end
		-- XBtnChars["card"] = cardCount.."/"..cardMax;
	-- end
-- Output
	local usrtxt={[1]=XBSet["ClassV1"],[2]=XBSet["ClassV2"]};
	local output="";
	for i=1,2 do
		usrtxt[i],_=string.gsub(usrtxt[i],"%[MLVL%]",tostring(XBtnChars["ml"]));
		usrtxt[i],_=string.gsub(usrtxt[i],"%[MCLASS%]",tostring(XBtnChars["mc"]));
		usrtxt[i],_=string.gsub(usrtxt[i],"%[MEXP%]",tostring(XBtnChars["mcurrExp"]));
		usrtxt[i],_=string.gsub(usrtxt[i],"%[MMAXEXP%]",tostring(XBtnChars["mmaxExp"]));
		usrtxt[i],_=string.gsub(usrtxt[i],"%[SLVL%]",tostring(XBtnChars["sl"]));
		usrtxt[i],_=string.gsub(usrtxt[i],"%[SCLASS%]",tostring(XBtnChars["sc"]));
		usrtxt[i],_=string.gsub(usrtxt[i],"%[SEXP%]",tostring(XBtnChars["scurrExp"]));
		usrtxt[i],_=string.gsub(usrtxt[i],"%[SMAXEXP%]",tostring(XBtnChars["smaxExp"]));
		usrtxt[i],_=string.gsub(usrtxt[i],"%[TLVL%]",tostring(XBtnChars["tl"]));
		usrtxt[i],_=string.gsub(usrtxt[i],"%[TCLASS%]",tostring(XBtnChars["tc"]));
		usrtxt[i],_=string.gsub(usrtxt[i],"%[TEXP%]",tostring(XBtnChars["tcurrExp"]));
		usrtxt[i],_=string.gsub(usrtxt[i],"%[TMAXEXP%]",tostring(XBtnChars["tmaxExp"]));
		usrtxt[i],_=string.gsub(usrtxt[i],"%[HONOR%]",tostring(XBtnChars["honor"]));
		--usrtxt[i],_=string.gsub(usrtxt[i],"%[CARD%]",tostring(XBtnChars["card"]));
		usrtxt[i],_=string.gsub(usrtxt[i],"%[TITLE%]",tostring(XBtnChars["title"]));
		usrtxt[i],_=string.gsub(usrtxt[i],"%[TITLEC%]",tostring(XBtnChars["titleC"]));
		usrtxt[i],_=string.gsub(usrtxt[i],"%[QUEST%]",tostring(XBtnChars["quest"]));
		usrtxt[i],_=string.gsub(usrtxt[i],"%[DAY%]",tostring(XBtnChars["daily"]));
		usrtxt[i],_=string.gsub(usrtxt[i],"%[CQUEST%]",tostring(XBtnChars["CQuest"]));
	end
	if (XBSet["ClassT1"]==true) then output=usrtxt[1]; end
	if (XBSet["ClassT2"]==true) then
		if (XBSet["ClassT1"]==true) then output=output.."\n"..usrtxt[2]; else output=usrtxt[2]; end
	end
	XBarClass_F_Text:SetText(output);
end

function XBarClass_Quest()
	XBtnChars["CQuest"] = 0;
	for i = 420034, 424650 do
		local complete = CheckQuest(i);
		if complete==2 then
			XBtnChars["CQuest"] = XBtnChars["CQuest"] + 1;
		end
	end
end