XBtnClock={
	["start"]=GetTime(),["time"]=0,["12"]=0,["24"]=0,
	["hour"]=0,["mins"]=0,["_hour"]=0,["_mins"]=0,
	["clock"]="",["date"]="",["game"]="",["total"]="",
	["update"]=0,
};
 
function XBarClock_OnEvent(this,event)
	if (event=="VARIABLES_LOADED") then this.date=0; end
end

function XBarClock_OnUpdate(this,elapsedTime)
	XBtnClock["update"]=XBtnClock["update"]+elapsedTime;
	if (XBtnClock["update"]>=1) then -- count every second
		XBtnClock["update"]=0;
		--[[if (this.starting) then
			this.remaining=this.remaining-elapsedTime;
			if (this.remaining>0) then XBarClock_SetTime(this,this.duration,this.remaining);
			else this.starting=nil; end]]
		--end
		XBarClock_SetTime(this,60,60-tonumber(os.date("%S")));
		XBtnClock["time"]=GetTime()-XBtnClock["start"];
		XBtnClock["_hour"]=string.format("%02d",XBtnClock["hour"]);
		XBtnClock["hour"]=math.floor(XBtnClock["time"]/3600);
		XBtnClock["_mins"]=string.format("%02d",XBtnClock["mins"]);
		XBtnClock["mins"]=((XBtnClock["time"]-(XBtnClock["hour"]*3600))/60);
		if (XBtnClock["_mins"]<string.format("%02d",XBtnClock["mins"])) then XBSet["PlayedMins"]=XBSet["PlayedMins"]+1; end
		if (XBSet["PlayedMins"]>59) then XBSet["PlayedHour"]=XBSet["PlayedHour"]+1; XBSet["PlayedMins"]=0; end
		if (XBtnClock["_hour"]<string.format("%02d",XBtnClock["hour"])) then XBSet["PlayedHour"]=XBSet["PlayedHour"]+1; end
		if (XBSet["PlayedHour"]>23) then XBSet["PlayedDays"]=XBSet["PlayedDays"]+1; XBSet["PlayedHour"]=0; end
		XBtnClock["12"]=os.date("%I:%M.%S %p");
		XBtnClock["24"]=os.date("%H:%M.%S");
		XBtnClock["date"]=os.date("%a %b/%d-%Y");
		XBtnClock["game"]=string.format("%02d:%02d",XBtnClock["hour"],XBtnClock["mins"]);
		XBtnClock["total"]=string.format("%d "..DAYS.." %02d:%02d",XBSet["PlayedDays"],XBSet["PlayedHour"],XBSet["PlayedMins"]);
	-- Output
		local usrtxt={[1]=XBSet["ClockV1"],[2]=XBSet["ClockV2"],[3]=XBSet["ClockV3"],[4]=XBSet["ClockV4"],[5]=XBSet["ClockV5"]};
		local output="";
		for i=1,5 do
			usrtxt[i],_=string.gsub(usrtxt[i],"%[TIME24%]",(XBtnClock["24"] or 0));
			usrtxt[i],_=string.gsub(usrtxt[i],"%[TIME12%]",(XBtnClock["12"] or 0));
			usrtxt[i],_=string.gsub(usrtxt[i],"%[DATE%]",(XBtnClock["date"] or ""));
			usrtxt[i],_=string.gsub(usrtxt[i],"%[ONLINE%]",(XBtnClock["game"] or ""));
			usrtxt[i],_=string.gsub(usrtxt[i],"%[TOTALONLINE%]",(XBtnClock["total"] or ""));
		end
		if (XBSet["ClockT1"]==true) then
			if (this.date==1) then output=usrtxt[3]; elseif (this.clock==12) then output=usrtxt[2]; else output=usrtxt[1]; end
		end
		if (XBSet["ClockT2"]==true) then
			if (this.game==1) then if (XBSet["ClockT1"]==true) then output=output.."\n"..usrtxt[5]; else output=usrtxt[5]; end
			else if (XBSet["ClockT1"]==true) then output=output.."\n"..usrtxt[4]; else output=usrtxt[4]; end; end
		end
		XBarClock_F_Text:SetText(output);
	end
end

function XBarClock_OnClick(key,this)
	if (key=="RBUTTON") then if (this.date==1) then this.date=0; else this.date=1; end
	elseif (key=="LBUTTON" and IsShiftKeyDown()) then if (this.game==1) then this.game=0; else this.game=1; end
	elseif (key=="LBUTTON") then if (this.clock==12) then this.clock=24; else this.clock=12; end; end
end

function XBarClock_SetTime(this,duration,remaining)
	if (duration>0 and remaining>0) then
		XBarClock_B_Icon:SetCooldown(duration,remaining);
		this.starting=1; this.duration=duration; this.remaining=remaining;
	end
end